VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   8415
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   11415
   LinkTopic       =   "Form1"
   ScaleHeight     =   8415
   ScaleWidth      =   11415
   StartUpPosition =   3  'Windows-Standard
   Begin VB.PictureBox picDest 
      Height          =   8235
      Left            =   4020
      ScaleHeight     =   8175
      ScaleWidth      =   7215
      TabIndex        =   1
      Top             =   60
      Width           =   7275
   End
   Begin VB.PictureBox picSource 
      AutoSize        =   -1  'True
      Height          =   3900
      Left            =   60
      Picture         =   "Form1.frx":0000
      ScaleHeight     =   3840
      ScaleWidth      =   3840
      TabIndex        =   0
      Top             =   60
      Width           =   3900
   End
   Begin VB.Timer Timer1 
      Interval        =   50
      Left            =   540
      Top             =   4380
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Declare Function StretchBlt Lib "gdi32" _
        (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, _
        ByVal nWidth As Long, ByVal nHeight As Long, _
        ByVal hSrcDC As Long, ByVal xSrc As Long, _
        ByVal ySrc As Long, ByVal nSrcWidth As Long, _
        ByVal nSrcHeight As Long, ByVal dwRop As Long) As Long
        
Private Declare Function SetStretchBltMode Lib "gdi32" _
        (ByVal hdc As Long, ByVal nStretchMode As Long) As Long
    
Private Declare Function SetBrushOrgEx Lib "gdi32.dll" ( _
                 ByVal hdc As Long, _
                 ByVal nXOrg As Long, _
                 ByVal nYOrg As Long, _
                 lppt As Any) As Long
                 
Private Const SRCCOPY = &HCC0020
Private Const DELETESCANS = 3
Private Const HALFTONE = 4

Private Const pi As Double = 3.141592654

Private xTable() As Double
Private yTable() As Double
Private xStep As Long
Private yStep As Long

Private Sub Form_Load()
    picSource.ScaleMode = vbPixels
    picDest.ScaleMode = vbPixels
    picDest.AutoRedraw = True
End Sub


Private Sub Timer1_Timer()
    Static msCountdown As Long
    Static ixTable As Long, iyTable As Long
    
    If msCountdown = 0 Then
        msCountdown = 10000
        SetNewTable
        ixTable = 0: iyTable = 0
    End If
    msCountdown = msCountdown - 50
    
    picDest.Cls
    Stretch picSource, picDest, ixTable, xTable, iyTable, yTable

    ixTable = ixTable + xStep
    If ixTable > UBound(xTable) Then ixTable = ixTable - UBound(xTable)

    iyTable = iyTable + yStep
    If iyTable > UBound(yTable) Then iyTable = iyTable - UBound(yTable)
End Sub


Private Sub SetNewTable()
    Static cCalls As Long
    Dim i As Long, j As Long
    Dim yStart As Double, yEnd As Double
    Dim Angle As Double
    
    Select Case cCalls
    Case 0
        ReDim xTable(127)
        ReDim yTable(127)
        For i = 0 To UBound(xTable)
            xTable(i) = Sin(pi * i / 64) + 1.5
        Next
        For i = 0 To UBound(yTable)
            yTable(i) = Sin(pi * i / 64) + 1.5
        Next
        xStep = 1: yStep = 1
    Case 1
        ReDim xTable(127)
        ReDim yTable(127)
        For i = 0 To UBound(xTable)
            xTable(i) = Sin(pi * i / 64) + 1.5
        Next
        For i = 0 To UBound(yTable)
            yTable(i) = Cos(pi * i / 64) + 1.5
        Next
        xStep = 1: yStep = 1
    Case 2
        ReDim xTable(127)
        ReDim yTable(128 * 5 - 1)
        For i = 0 To UBound(xTable)
            xTable(i) = Sin(pi * i / 64) + 1.5
        Next
        For i = 0 To UBound(yTable)
            yTable(i) = (Sin(pi * i / 64) + Sin(pi * i / 80)) + 1.5
        Next
        xStep = 1: yStep = 3
    Case 3
        ReDim xTable(128 * 128 - 1)
        ReDim yTable(128 * 128 - 1)

        For i = 0 To 127
            yStart = Sin(pi * i / 256)
            yEnd = 1
            For j = 0 To 127
                xTable(i * 128 + j) = Sin(pi * i / 256)
                yTable(i * 128 + j) = yStart + (yEnd - yStart) / 128 * j
            Next
        Next
        xStep = 128: yStep = 128
        cCalls = -1
    End Select
    
    cCalls = cCalls + 1
End Sub

Private Sub Stretch(picSource As PictureBox, picDest As PictureBox, ByVal ixTable As Long, xTable() As Double, ByVal iyTable As Long, yTable() As Double)
    Dim x As Long, i As Long
    Dim xWidth As Double
    Dim xShift As Long, yShift As Long   'zur anpassung an picDest Gre
    Dim xDest As Long, xSource As Long
    Dim WidthDest As Double, WidthSource As Long
    
    'alle x Faktoren summieren um die Breite des fertigen Bildes zu kennen
    x = ixTable
    For i = 0 To 128
        xWidth = xWidth + xTable(x)
        x = x + 1
        If x > UBound(xTable) Then x = 0
    Next
    xShift = (picDest.ScaleWidth - (xWidth * 2)) / 2
    yShift = (picDest.ScaleHeight - picSource.ScaleHeight) / 2
    
    'SetStretchBltMode picDest.hdc, HALFTONE        'zu langsam :P
    'SetBrushOrgEx picDest.hdc, 0, 0, ByVal 0
    
    SetStretchBltMode picDest.hdc, DELETESCANS      'schneller :D
    
    xDest = xShift: xSource = 0
    For x = 0 To 256 Step 2
        WidthSource = WidthSource + 2
        WidthDest = WidthDest + xTable(ixTable) * 2
        If WidthDest > 1 Then
            
            StretchBlt picDest.hdc, xDest, yShift + (1 - yTable(iyTable)) / 2 * 256, _
                    WidthDest, yTable(iyTable) * 256, picSource.hdc, xSource, 0, WidthSource, 256, SRCCOPY
        
            xSource = xSource + WidthSource
            xDest = xDest + WidthDest
            WidthSource = 0
            WidthDest = WidthDest - CLng(WidthDest)
        End If
        
        ixTable = ixTable + 1
        If ixTable > UBound(xTable) Then ixTable = 0
        
        iyTable = iyTable + 1
        If iyTable > UBound(yTable) Then iyTable = 0
    Next
End Sub

